<!DOCTYPE html>
<html>
	<head lang="es">
		<meta charset="utf-8">
		<title>Trabajo en grupo TG3</title>
		<link rel="stylesheet" href="style.css">
		<link href="https://fonts.googleapis.com/css?family=Oswald&display=swap" rel="stylesheet">
		<link href="https://fonts.googleapis.com/css?family=Caladea|Oswald&display=swap" rel="stylesheet">
	</head>
<body>
	<header class="encabezado" id="0">
		<h1>Desarrollo con Tecnologías Emergentes. Curso 2019-20<br>
			Trabajo TG3 del grupo M4<br>
			Titulo: TG3. Implementar dos tecnologias emergentes</h1>
	</header>
	<nav>
		<div class="navegacion">
			<a href="#0" class="boton">TG3</a>
			<a href="#1" class="boton">1</a>
			<a href="#2" class="boton">2</a>
			<a href="#3" class="boton">3</a>
			<a href="#4" class="boton">4</a>
			<a href="#5" class="boton">5</a>
			<a href="#6" class="boton">6</a>
			<a href="#6" class="boton">7</a>
		</div>
		<ul>
			<li class="index"><a href="#1">1. Informacion general</a></li>
			<li class="index"><a href="#2">2. Requisitos de los prototipos a implementar</a></li>
			<li class="index"><a href="#3">3. Criterios de comparacion de los prototipos</a></li>
			<li class="index"><a href="#4">4. Implementación del prototipo (Django)</a></li>
			<li class="index"><a href="#5">5. Implementación del prototipo (Flask)</a></li>
			<li class="index"><a href="#6">6. Comparacion de los prototipos</a></li>
			<li class="index"><a href="#7">7. Conclusiones</a></li>
		</ul>
	</nav>

	<main>
		<section class="seccion" id="1">
			<h2>1. Información general</h2>
			<h3>1.1 Autores</h3>
			<ul>
			</br>
				<li><b>Daniel Pérez Moreno | </b><i>(Coordinador)</i></li>
				<li><b>Jorge Berbel Ruiz</b></li>
				<li><b>Aarón Vicente Santos</b></li>
				<li><b>Daniel Díaz Fernández</b></li>
				<li><b>Miguel Ángel Benito</b></li>
			</ul>
			<h3>1.2 Proyecto Scrum y repositorio en GitLab</h3>
			<div class="enlace"><a href="https://gitlab.com/dte2020/t4/tg3" target="blank" >Trabajo Grupal 3 (Grupo 4)</a></div></br>
			<div class="enlace"><a href="https://gitlab.com/dte2020/t4/tg3/-/milestones/1" target="blank" >Milestone Final "TG3" (Grupo 4)</a></div>
			<h3>1.3 Burndown chart</h3>
			<p>Diagrama Burndown final del Sprint TG3.</p>
			<div class="milestone"><img src="images/millestone.PNG"></div>
			<h3>1.4 Presentación del trabajo</h3>
			<p>Presentación del trabajo formato PPT</p>
			<div class="enlace"><a href="PythonWebFrameworks3.pptx" target="blank" download>Presentacion
			</a></div>
		</section>
		<section class="seccion" id="2">
			<h2>2. Requisitos de los prototipos a implementar</h2>
			<p>En este trabajo se va a presentar el desarrollo de dos API REST utilizando Flask y Django.</p>
			<ul>Conocimientos o familiaridad con:
				<li>Python (3.8)</li>
				<li>Sistema operativo (Windows)</li>
				<li>Consola del sistema (CMD)</li>
				<li>Editor de código (Visual Studio Code)</li>
				<li>Plataforma para facilitar el desarrollo de APIs (Postman)</li>
			</ul>
			<h3>Librerías</h3>
			<p><ul><li>El cumplimiento de estos requisitos es posible gracias a la importación de librerías. Estas librerías van a ser
			diferentes para cada framework. </li>
			 <li>En el caso de Flask, las librerías se han añadido de forma específicas, por ejemplo <b>SQLAlchemy</b> y <b>Marshmallow</b>, que añaden 
			organización de URLs y tratamiento SQL. </li>
			 <li>En el caso de Django, se ha importado una librería más grande y general, que es <b>TastyPie</b>. TastyPie ofrece más funciones de las que hemos llegado a necesitar, pero nos asegura el desarrollo <br>
			  correcto de la API REST y de sus requisitos.</li></ul></p>
			<h3>2.1 Catálogo de requisitos</h3>
			<table>
				<tr>
					<th>Requisitos</th>
					<th>Descripcion</th>
				</tr>
				<tr>
					<td>Lenguaje de Programacion</td>
					<td>El lenguaje de desarrollo debe de ser Python.</td>
				</tr>
				<tr>
					<td>Añadir Usuario</td>
					<td>La aplicación debe permitir añadir un nuevo usuario (username, url, email, grupo de acceso).</td>
				</tr>
				<tr>
					<td>Consultar Usuario</td>
					<td>La aplicación debe permitir consultar un usuario ya creado.</td>
				</tr>
				<tr>
					<td>Consultar Grupo</td>
					<td>La aplicación debe permitir consultar todos los usuarios de todos los grupos.</td>
				</tr>
				<tr>
					<td>Eliminar Usuarios</td>
					<td>La aplicación debe permitir eliminar la tabla generada con todos los usuarios.</td>
				</tr>
				<tr>
					<td>Entorno API REST</td>
					<td>Facilitar al framework una organización de trabajo enfocada al desarrollo de una API REST.</td>
				</tr>
				<tr>
					<td>Manejo de rutas</td>
					<td>Separación de las URLs y añadido de funciones para poder trabajar con ellas fácilmente.</td>
				</tr>
				<tr>
					<td>Diseño de modelos BBDD</td>
					<td>Diseñar modelos que se puedan integrar directamente en la base de datos.</td>
				</tr>
				<tr>
					<td>Vista JSON</td>
					<td>Cualquier documento JSON debe ser reformateado para su vista en el buscador.</td>
				</tr>
				<tr>
					<td>Front-end</td>
					<td>Capacidad de la aplicación para soportar un diseño front-end.</td>
				</tr>
				<tr>
					<td>Sesiones Web</td>
					<td>Capacidad de mantener sesiones de los usuarios que ingestan nuevos datos.</td>
				</tr>
				<tr>
					<td>Sesiones BBDD</td>
					<td>Capacidad de una unica sesion con un usuario para la base de datos con la que gestionar el contenido.</td>
				</tr>	
				<tr>
					<td>Contenido BBDD</td>
					<td>Crear una unica tabla añadiendo las columnas correspondientes con los datos de los usuarios.</td>
				</tr>
				<tr>
					<td>Compatibilidad WSGI</td>
					<td>La aplicacion debe soportar una integracion con WSGI para servir las paginas web.</td>
				</tr>
				<tr>
					<td>Flexibilidad</td>
					<td>Capacidad de adaptarse a cambios repentinos sin modificar todo el codigo, solo el necesario para no desmembrar la API.</td>
				</tr>
				<tr>
					<td>Integracion y Escalabilidad</td>
					<td>Capacidad de incluir nuevos modulos y componentes para un futuro desarrollo mas avanzado de la aplicacion.</td>
				</tr>
				<tr>
					<td>Despliegues</td>
					<td>Capacidad de poder incluir un sencillo despliegue para las fases de produccion en el futuro.</td>
				</tr>
				<tr>
					<td>Tamaño de Codigo</td>
					<td>No debe superar las 300 lineas de codigo para un primer prototipo facilitando la carga de trabajo.</td>
				</tr>
				<tr>
					<td>Segmentacion</td>
					<td>El codigo debe estar segmentado y separado en carpetas favoreciendo la comprensión del desarrollo de la aplicación.</td>
				</tr>					
			</table>
		</section>
		<section class="seccion" id="3">
			<h2>3. Criterios de comparación de los prototipos</h2>
			<p>Los criterios de comparación </p>
			

			

				<h3>3.1 Criterio 1:Cantidad de componenetes </h3>
			<ul>
				<li>Nombre del criterio: Cantidad de componenetes necesarios</li>
				<li>Descripcion: Componentes necesarios para la . </li>
				<li>Tipo de valor: número (seg/mseg...))</li>
			</ul>
				<h3>3.2 Criterio 2: Peso de la APP</h3>
				<ul>
					<li>Nombre del criterio: Peso de la APP</li>
					<li>Descripcion: Cantidad de memoria que ocupará. </li>
					<li>Tipo de valor: número (gb/mb...)</li>
				</ul>
				<h3>3.3 Criterio 3:Velocidad de ejecución</h3>
				<ul>
					<li>Nombre del criterio: Velocidad de ejecución</li>
					<li>Descripcion: Calculo de tiempo de carga necesario para el correcto funcionamiento de la api. </li>
					<li>Tipo de valor: número (seg/mseg...))</li>
				</ul>
				<h3>3.4 Criterio 4: Lineas de código</h3>
				<ul>
					<li>Nombre del criterio: Lineas de código</li>
					<li>Descripcion: Cantidad de lineas de código necesarias para el desarrollo de la aplicación </li>
					<li>Tipo de valor: número entero</li>
				</ul>
				<h3>3.5 Criterio 5: Número de Librerias</h3>
				<ul>
					<li>Nombre del criterio: Número de Librerias</li>
					<li>Descripcion: Cantidad de librerias implementadas y necesarias para el funcionamiento del código </li>
					<li>Tipo de valor: número entero</li>
				</ul>
				<h3>3.6 Criterio 6: Ajuste de texto en pantalla</h3>
				<ul>
					<li>Nombre del criterio: Ajuste de texto en pantalla</li>
					<li>Descripcion: El contenido del texto de la app deberá corresponder a la dependencia apf que la publique</li>
					<li>Tipo de valor: booleano (cumple o no)</li>
				</ul>
				<h3>3.7 Criterio 7: Usabilidad</h3>
				<ul>
					<li>Nombre del criterio: Usabilidad de la app. </li>
					<li>Descripcion: Este criterio indica la facilidad o la amabilidad de la aplicación al usarse.</li>
					<li>Tipo de valor: texto libre.</li>
				</ul>
				<h3>3.8 Criterio 8: Número de librerías</h3>
				<ul>
					<li>Nombre del criterio: Número de librerías</li>
					<li>Descripcion: Número de librerías que necesita la aplicación desarrollada para que funcione correctamente.</li>
					<li>Tipo de valor: numérico.</li>
				</ul>
				<h3>3.9 Criterio 9: Número de funciones</h4>
				<ul>
					<li>Nombre del criterio: Número de funciones.</li>
					<li>Descripcion: Número de funciones que utiliza la aplicación desarrollada en su ejecución.</li>
					<li>Tipo de valor: numérico.</li>
				</ul>
				<h3>3.10 Criterio 10: Curva de aprendizaje</h4>
				<ul>
					<li>Nombre del criterio: Curva de aprendizaje.</li>
					<li>Descripcion: Este criterio nos indica el grado de éxito obtenido durante el aprendizaje del transcurso del tiempo de desarrollo de la aplicación en cuestión.</li>
					<li>Tipo de valor: texto libre</li>
				</ul>
				<h3>3.11 Criterio 11: Diseño de interfaz</h4>
				<ul>
					<li>Nombre del criterio: Diseño de interfaz.</li>
					<li>Descripcion: El grado de complejidad del diseño de la interfaz de la aplicación.</li>
					<li>Tipo de valor: texto libre</li>
				</ul>
				<h3>3.12 Criterio 12: Escalabilidad.</h4>
				<ul>
					<li>Nombre del criterio: Escalabilidad.</li>
					<li>Descripcion: La aplicación presenta una mejor disposición para aumentar o mostrar un mayor grado de escalabilidad.</li>
					<li>Tipo de valor: texto libre</li>
				</ul>
				<h3>3.13 Criterio 13: Integridad</h4>
				<ul>
					<li>Nombre del criterio: Integridad.</li>
					<li>Descripcion: Este criterio se refiere a la precisión y coherencia general de la apliación desarrollada,
					el correcto almacenamiento y funcionamiento de sus datos y la seguridad de la aplicación.</li>
					<li>Tipo de valor: texto libre.</li>
				</ul>

		</section>

		<section class="seccion" id="4">
			<h2>4. Implementación del prototipo (Flask)</h2>
			<p>Este pequeño prototipo construido en Flask se encarga de almacenar en una pequeña base de datos un conjunto de usuarios, 
			los cuales introducen sus datos personales mediante una aplicación externa con el fin de ser gestionados por un administrador 
			para publicarlos en una página web.</p>
			<h3>4.1 Contenido</h3>
			<p>La carpeta del prototipo cuenta con diferentes subcarpetas y archivos, entre los cuales destacan:</p>
			<ul>
				<li>
				<div class="enlace"><a href="https://gitlab.com/dte2020/t4/tg3/-/tree/master/prototipo-B/app" target="blank" ><b>app</b></a></div>
				  :   Contiene los archivos de modelización, vistas y templates de nuestra aplicación</li>
				<li>
				<div class="enlace"><a href="https://gitlab.com/dte2020/t4/tg3/-/tree/master/prototipo-B/images" target="blank" ><b>images</b></a></div>
				  :   Contiene las imagenes incorporadas en el README.md</li>
				<li>
				<div class="enlace"><a href="https://gitlab.com/dte2020/t4/tg3/-/tree/master/prototipo-B/config.py" target="blank" ><b>config.py</b></a></div>
				  :   Contiene el código de la configuración de parámetros y variables</li>
				<li>
				<div class="enlace"><a href="https://gitlab.com/dte2020/t4/tg3/-/tree/master/prototipo-B/curd.sqlite" target="blank" ><b>curd.sqlite</b></a></div>
				  :   Contiene los datos almacenandolos en una base de datos</li>
				<li>
				<div class="enlace"><a href="https://gitlab.com/dte2020/t4/tg3/-/tree/master/prototipo-B/my_app.py" target="blank" ><b>my_app.py</b></a></div>
				  :   Contiene el código la inicialización de la aplicación</li>
				<li>
				<div class="enlace"><a href="https://gitlab.com/dte2020/t4/tg3/-/tree/master/prototipo-B/README.md" target="blank" ><b>README.md</b></a></div>
				  :   Contiene información detallada de nuestra aplicación sobre su construcción, estructura, y funcionamiento</li>
			</ul>
			<h3>4.2 Implementación</h3>
			<p>La descripción de la aplicación viene descrita en la propia carpeta del prototipo, donde se muestra un breve documento (README.md) el cual contiene
			los apartados principales para poder construir nuestra aplicación desde 0 e inicializarla y ejecutarla.</p>
			<div class="enlace"><a href="https://gitlab.com/dte2020/t4/tg3/-/tree/master/prototipo-B" target="blank" ><b>Prototipo (Flask)</b></a></div>
		</section>

		<section class="seccion" id="5">
			<h2>5. Implementación del prototipo (DJANGO)</h2>
			<p>Este pequeño prototipo construido en Django lo creamos para una aplicación web de toma de notas de Google Keep-esque.
			Queremos construir una API completa de REST con los puntos finales de CRUD, para crear, leer, actualizar y eliminar notas.
            La buena  noticia es que en lugar de abordar estos puntos finales individualmente, Django nos permite más o menos crearlos
            todos de  una sola vez.</p>
			<h3>5.1 Contenido</h3>
			<p>La carpeta del prototipo A de Django cuenta con diferentes subcarpetas y archivos, entre los cuales destacan:</p>
			<ul>
				<li>
				<div class="enlace"><a href="https://gitlab.com/dte2020/t4/tg3/-/tree/master/prototipo-A/src" target="blank" ><b>src</b></a></div>
				  :   Contiene todos los archivos y carpetas para la inicialización de la API de REST con Django</li>
				<li>
				<div class="enlace"><a href="https://gitlab.com/dte2020/t4/tg3/-/tree/master/prototipo-A/images" target="blank" ><b>images</b></a></div>
				  :   Contiene las imagenes incorporadas en el README.md</li>
				<li>
				<div class="enlace"><a href="https://gitlab.com/dte2020/t4/tg3/-/tree/master/prototipo-A/src/api" target="blank" ><b>api</b></a></div>
				  :   Contiene el código de la API, inicialización de la misma y sus migraciones.</li>
				<li>
				<div class="enlace"><a href="https://gitlab.com/dte2020/t4/tg3/-/tree/master/prototipo-A/src/notable_django" target="blank" ><b>notable_django</b></a></div>
				  :   Contiene los datos de las URLs, las configuraciones además de el propio ini también.</li>
				<li>
				<div class="enlace"><a href="https://gitlab.com/dte2020/t4/tg3/-/blob/master/prototipo-A/src/manage.py" target="blank" ><b>manage.py</b></a></div>
				  :   Contiene el código de manejo de ambas la api y notable_django</li>
				<li>
				<div class="enlace"><a href="https://gitlab.com/dte2020/t4/tg3/-/tree/master/prototipo-A/README.md" target="blank" ><b>README.md</b></a></div>
				  :   Contiene información detallada de nuestra aplicación de API de REST con Django sobre su construcción, estructura, y funcionamiento</li>
			</ul>
			<h3>5.2 Implementación</h3>
			<p>La descripción de la aplicación viene descrita en la propia carpeta del prototipo, donde se muestra un breve documento (README.md) el cual contiene
			los apartados principales para poder construir nuestra aplicación desde 0 e inicializarla y ejecutarla.</p>
			<div class="enlace"><a href="https://gitlab.com/dte2020/t4/tg3/-/tree/master/prototipo-A" target="blank" ><b>Prototipo (DJANGO)</b></a></div>
		</section>

		<section class="seccion" id="6">
			<h2>6. Comparacion de los prototipos</h2>
			<p>Presentamos la tabla comparativa de los criterios de comparación para ambas APIS con los diferentes frameworks, Flask y DJango.</p>
			<table>
				<tr>
					<th>Criterio</th>
					<th>Prototipo Flask</th>
					<th>Prototipo DJango</th>
					<th>Comentarios</th>

				</tr>
				<tr>
					<td>Cantidad de componenetes</td>					
					<td>20 Archivos ( 8 carpetas)</td>
					<td>37 archivos (12 carpetas)</td>
					<td>Flask vemos que es más eficitente en organizacion de componenetes</td>
				</tr>
				<tr>
					<td>Peso de la APP</td>
					<td>316 kb</td>
					<td>344 kb</td>
					<td>La aplicación en Flask pesa más debido a la cantidad de datos que contiene, a igualdad de condiciones pesaría menos</td>
				</tr>
				<tr>
					<td>Velocidad de ejecución</td>
					<td>0.060</td>
					<td>0.048</td>
					<td>Prácticamente imperceptible la diferencia entre ambos</td>
				</tr>
				<tr>
					<td>Lineas de código</td>
					<td>227</td>
					<td>92</td>
					<td>El código del prototipo A es menos eficiente a la hora de programar este tipo de api</td>
				</tr>
				<tr>
					<td>Multiplataforma</td>
					<td>Sí</td>
					<td>Sí</td>
					<td>Ambos prototipos son funcionales en diferentes sistemas y entornos</td>
				</tr>
				<tr>
					<td>Ajuste de texto en pantalla</td>
					<td>Sí</td>
					<td>Sí</td>
					<td>Ambos prototipos cumplen esta condición correctamente</td>
				</tr>
				<tr>
					<td>Usabilidad</td>
					<td>Mayor</td>
					<td>Menor</td>
					<td>Flask presenta mayor sencillez en su utilización.</td>
				</tr>
				<tr>
					<td>Número de librerías</td>
					<td>6</td>
					<td>3</td>
					<td>Flask necesita el doble librerías para esta API.</td>
				</tr>
				<tr>
					<td>Número de funciones</td>
					<td>34</td>
					<td>23</td>
					<td>Flask presenta un ligero mayor número de funciones</td>
				</tr>
				<tr>
					<td>Curva de aprendizaje</td>
					<td>Menor</td>
					<td>Mayor</td>
					<td>Flask es mucho más sencillo y especialmente enfocado a novatos.</td>
				</tr>
				<tr>
					<td>Diseño de interfaz</td>
					<td>Más sencilla</td>
					<td>Sencilla</td>
					<td>El diseño de ambas interfaces son fáciles con python, pero destaca Flask al ser aún más sencilla de implementar.</td>
				</tr>
				<tr>
					<td>Escalabilidad</td>
					<td>Débil</td>
					<td>Potente</td>
					<td>Django es un framework más potente y no se considera micro-framework como Flask.</td>
				</tr>
				<tr>
					<td>Integridad</td>
					<td>Alta</td>
					<td>Un poco más alta</td>
					<td>Ambos frameworks son seguros e íntegros pero Django emplea un manejo de versiones con actualizaciones más simples, 
					mientras que Flask es más complejo a la hora de mantener código.</td>
				</tr>
			</table>
		</section>

		<section class="seccion" id="7">
			<h2>7. Conclusiones</h2>
			<p>A modo de conclusión, aclarar que los criterios elegidos son los más importantes, bajo nuestro punto de vista, para poder comparar correctamente dos prototipos parecidos en tamaño y usabilidad.
				Entre estos destacan la escalabilidad, lineas de código y el tamaño de la aplicación ya que es lo que más nos preocuparía planteandolo en un concepto de largo plazo, puesto que nos permitirá diferenciar claramente cuál es la mejor opción cuando queramos aumentar de tamaño nuestro proyecto.
				En este caso, que estamos tratando con aplicaciones pequeñas y sencillas, recomendamos Flask como la mejor opción. No obstante, dependiendo de la escalabilidad y la precisión con la que se quieren cumplir los requisitos, podría ser más útil Django, pues es más robusto y adaptable. La elección de un framework u otro depende del tamaño y del compromiso que tengamos con el proyecto.</p>
		</section>

	</main>

</body>

</html>